#!/bin/bash

if [ "$1" == "wham" ]; then
 file=wham.thermal
else
 exit 1
fi

# Check if file exist
if [ ! -f $file ]; then
    echo "CRITICAL: out $file do not exist"
    exit 2
fi

error=0
max=`awk '{print $1,$7*1}' $file | sort -n -k 2 | awk 'END{print $1}'`
echo 'T of max Cv(T) ' $max
rms=`awk '{if ($1<280) {a=a+$5;n++}}END{print a/n}' $file`
echo 'average rms for T<280 ' $rms

 if [ `grep differs wham.out* |wc -l` != "0" ]; then
  echo 'ERROR: energy differs remarkably from  the value read in'  
  echo 'first 10 warnings'
  grep differs wham.out*|head -10
  error=1
 fi

 if [ `echo "a=$max-313;if(0>a)a*=-1;a>100.0"|bc -l` != "0" ]; then
  echo 'ERROR wrong T max of Cv(T) by more than 100 K'
  error=1
 fi

 if [ `echo "a=$rms-8.6;if(0>a)a*=-1;a>2.0"|bc -l` != "0" ]; then
  echo 'ERROR wrong average rms for T<280 by more than 2.0'
  error=1
 fi

 if [ "$error" != "0" ];then
   exit 1
 fi
 